#define CNT_READ 20 //co tyle wybudze bdzie odczytywany ADC
volatile uint8_t cyfry[4] = {10, 10, 10, 10}; //cyfry do wystawienia na LCD
//pozycja zaczonej kropki: 0 - pierwsza, 1 - druga, 2 - trzecia, co innego - brak
volatile uint8_t poz_kropki = 3;
volatile uint8_t cnt_read = CNT_READ; //aby natychmiast odczyta ADC
volatile uint32_t adc; //warto pobrana z ADC
volatile uint8_t range = 0; //0 - zakres do 10V, 1 - zakres do 100V
volatile uint8_t measure_good = 0; //jeeli 1, to wynik pomiaru by juz wykorzystany

//Przerwanie od zakoczonej konwersji ADC
//pusta obsuga przerwania, aby nie pozostao nieobsuone
ISR(ADC_vect){ }

//Gwna funkcja programu

int main(void){
//...
	while(1){
		cnt_read++; //inkrementacja zmiennej do odczytania ADC
		if(cnt_read >= CNT_READ){
			cnt_read = 0; //przygotowanie do nastpnego odliczenia
			PORTA |= (1<<PORTA1); //zaczenie AREF
			ADMUX = (1<<REFS1) | (1<<MUX1); //zewntrzny AREF + ADC2 jako wejcie
			
			if(range){ //zaczenie tranzystora modyfikujcego dzielnik wejciowy
				PORTA |= (1 << PORTA3); //do 100V: zaczony
			}else{
				PORTA &= ~(1 << PORTA3); //do 10V: wyczony
			}
			
			measure_good = 0; //wyzerowanie flagi
			ADCH = 0; //wyczyszczenie rejestrw
			ADCL = 0;
			//oczekiwanie na ustabilizowanie rda napicia odniesienia
			_delay_ms(1);
			//zaczenie przetwornika ADC
			ADCSRA = (1<<ADEN) | (1<<ADSC) | (1<<ADIE) | (1<<ADPS2) | (1<<ADATE);

			while(bit_is_clear(ADCSRA,ADIF)); //oczekiwanie na koniec pomiaru

			adc = ADCL | (ADCH << 8); //pobranie wyniku pomiaru
			PORTA &= ~(1<<PORTA1); //wyczenie rda napicia odniesienia
			//wyczenie ADC przez wyzerowanie rejestrw sterujcych jego prac
			ADMUX = 0;
			ADCSRA = 0;
			adc *= 1000; //bardzo prosta konwersja z przedziau 0-1023 na 0-999
			adc /= 1024;

			//1 - jeeli mierzono na zakresie do 10V i wynik jest poprawny
			if(adc < 999 && range == 0){
				poz_kropki = 1; //zacz kropk w odpowiednim miejscu
				cyfry[0] = 10; //wycz cyfr najbardziej na lewo
				cyfry[1] = adc / 100; //rozbicie jednej liczby na trzy cyfry
				adc -= cyfry[1] * 100;
				cyfry[2] = adc / 10;
				adc -= cyfry[2] * 10;
				cyfry[3] = adc;
				measure_good = 1; //wynik pomiaru zosta wykorzystany
			}

			//2 - jeeli przekroczono zakres do 10V
			if(adc >= 999 && range == 0){
				range = 1; //zmie zakres na 100V
				//oraz zablokuj moliwo uycia tego wyniku pomiaru
				measure_good = 1;
			}

			//3 - jeeli mierzono na zakresie do 100V i wynik jest poprawny
			if(adc < 999 && adc > 99 && range == 1 && measure_good == 0){
				poz_kropki = 2; //zacz kropk w odpowiednim miejscu
				cyfry[0] = 10; //wycz cyfr najbardziej na lewo
				cyfry[1] = adc / 100; //rozbicie jednej liczby na trzy cyfry
				adc -= cyfry[1] * 100;
				cyfry[2] = adc / 10;
				adc -= cyfry[2] * 10;
				cyfry[3] = adc;
				measure_good = 1; //wynik pomiaru zosta wykorzystany
			}

			//4 - jeeli na zakresie 100V podano napicie do 10V
			if(adc <= 99 && range == 1 && measure_good == 0){
				range = 0;//zmie zakres na 10V
				//oraz zablokuj moliwo uycia tego wyniku pomiaru
				measure_good = 1;
			}

			//5 - jeeli na zakresie do 100V zosta przekroczony zakres
			if(adc >= 999 && range == 1 && measure_good == 0){
				poz_kropki = 3; //wycz kropk
				cyfry[0] = 10; //napisz Ovf, jeeli wynik pomiaru przekracza 100V
				cyfry[1] = 11;
				cyfry[2] = 16;
				cyfry[3] = 13;
				//zablokuj moliwo uycia tego wyniku pomiaru
				measure_good = 1;
			}
		}
	}
	return 0;
}
